*if(strcmp(GenData(Solve_FluidFlow_in_Fluid),"Yes")==0 || strcmp(GenData(Solve_Temperature_in_Fluid),"Yes")==0 || strcmp(GenData(Solve_SpeciesConcentration_in_Fluid),"Yes")==0 || strcmp(GenData(Solve_PhiProblems_in_Fluid),"Yes")==0 || strcmp(GenData(Solve_FluidFlow_in_Solid),"Yes")==0 || strcmp(GenData(Solve_Temperature_in_Solid),"Yes")==0 || strcmp(GenData(Solve_SpeciesConcentration_in_Solid),"Yes")==0 || strcmp(GenData(Solve_PhiProblems_in_Solid),"Yes")==0)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
TDYN_3D; ! TDYN PROBLEM TYPE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
OutputUnits:   Length       =*gendata(Output_Length_units), 
	       Time         =*gendata(Output_Time_units), 
	       Mass         =*gendata(Output_Mass_units),
	       Temperature  =*gendata(Output_Temperature_units);
InternalUnits: Length       =*gendata(Internal_Length_units), 
	       Time         =*gendata(Internal_Time_units), 
	       Mass         =*gendata(Internal_Mass_units),
	       Temperature  =*gendata(Internal_Temperature_units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ProblemDefinition;
ConfigurationData: *\
*if(strcmp(gendata(Tcl_Extension),"Yes")==0)
Initialise_Tcl_Extension, Tcl_Script = "*tcl(TdynOutput::Base64Data Tcl_Script)"*\
*endif
;
GeneralData:  Number_of_Steps = *gendata(Number_of_Steps), Output_Step = *gendata(Output_Step), Output_Start = *gendata(Output_Start),
	      Time_increment = "*gendata(Time_increment);" *gendata(Time_increment_Units), Max_Iterations = *gendata(Max_Iterations),
	      NewRunVelocities = *gendata(Velocities_List), StepsNewRunVelocities = *gendata(Additional_Steps),
	      Initial_Steps = *gendata(Initial_Steps), Number_of_CPUs = *gendata(Number_of_CPUs), Start_Up_Control = *gendata(Start_Up_Control), Initialise_Flow_Field = *gendata(Initialise_Flow_Field),*\
*if(strcmp(gendata(Restart),"On")==0) 
, Restart*\
*endif 
*if(strcmp(gendata(Wall_Law_Type),"FixTau")==0) 
, OldLawOfTheWall*\
*endif 
*if(strcmp(gendata(Wall_Law_VFor),"On")==0) 
, GiveWallLawForces*\
*endif 
*if(strcmp(gendata(RefineMesh),"None")!=0) 
, Refine_Mesh = *gendata(RefineMesh)*\
*endif 
*if(strcmp(gendata(Use_Total_Pressure),"Yes")==0) 
, Total_Pressure *\
*endif 
*if(strcmp(gendata(Float_By_Density),"Yes")==0) 
, Float_By_Density *\
*endif 
, Pressure_BC_Type = *gendata(Pressure_Boundary_Conditions_Type), Velocity_BC_Type = *gendata(Velocity_Boundary_Conditions_Type), ODDLS_BC_Type = *gendata(ODDLS_Boundary_Conditions_Type);
PhysicalData:
   
*if(strcmp(gendata(Give_Gravity),"Yes")==0) 
 Gravity = *gendata(GravityOX) *gendata(GravityOY) *gendata(GravityOZ) *gendata(Gravity_Units),*\
*endif 
*if(strcmp(gendata(Give_Pressure_Origin),"Yes")==0) 
 Pres_Origin = *gendata(Pressure_Origin_OX) *gendata(Pressure_Origin_OY) *gendata(Pressure_Origin_OZ) *gendata(Geometry_Units),*\
*endif 
 Operating_Pressure = *gendata(Operating_Pressure) *gendata(Operating_Pressure_Units);
WriteResultsData:  Tdyn_PostMode = *gendata(Results_File)*\
*if(gendata(Initial_Data,int)!=0) 
, Initial*\
*endif 
*if(gendata(Velocity,int)!=0) 
, Velocity*\
*endif
*if(gendata(Velocity_Stress_Tensor,int)!=0)
, VelocityStress*\
*endif
*if(gendata(Pressure,int)!=0)
, Pressure*\
*endif
*if(gendata(Pressure_Gradient,int)!=0)
, GradPressure*\
*endif
*if(gendata(Total_Pressure,int)!=0)
, TotalPressure*\
*endif
*if(gendata(Temperature,int)!=0)
, Temperature*\
*endif
*if(gendata(Temperature_Gradient,int)!=0)
, GradTemperature*\
*endif
*if(gendata(Solid_Density,int)!=0)
, SolidDensity*\
*endif
*if(gendata(Species_Concentration,int)!=0)
, Concentration*\
*endif
*if(gendata(Wave_Elevation,int)!=0)
, Beta*\
*endif
*if(gendata(Wave_Elevation_Vector,int)!=0)
, BetaVector*\
*endif
*if(gendata(Density,int)!=0)
, Density*\
*endif
*if(gendata(Viscosity,int)!=0)
, Viscosity*\
*endif
*if(gendata(Compressibility_factor,int)!=0)
, CompressFactor*\
*endif
*if(gendata(Wall_Law_Traction,int)!=0)
, WallShearStress*\
*endif
*if(gendata(Tau_Parameter,int)!=0)
, TauParameter*\
*endif
*if(gendata(Distance,int)!=0)
, Distance*\
*endif
*if(gendata(Vorticity,int)!=0)
, Vorticity*\
*endif
*if(gendata(Eddy_Viscosity,int)!=0)
, EddyViscosity*\
*endif
*if(gendata(EddyKin_Energy,int)!=0)
, EddyKinEnergy*\
*endif
*if(gendata(Epsilon,int)!=0)
, Epsilon*\
*endif
*if(gendata(Omega,int)!=0)
, Omega*\
*endif
*if(gendata(Tau_Eddy,int)!=0)
, KTau*\
*endif
*if(gendata(Mesh_Deformation,int)!=0)
, MeshDeformation*\
*endif
*if(gendata(Eulerian_Velocity,int)!=0)
, EulerianVelocity*\
*endif
*if(gendata(Real_Velocity,int)!=0)
, VelocityWallRes*\
*endif
*if(gendata(Heat_Flux,int)!=0)
, HeatFluxes*\
*endif
*if(gendata(VariableResult,int)!=0)
, Variable *\
*endif
*if(gendata(UserDefinedF1,int)!=0)
, UserDefFluid1*\
*endif
*if(gendata(UserDefinedF2,int)!=0)
, UserDefFluid2*\
*endif
*if(gendata(UserDefinedF3,int)!=0)
, UserDefFluid3*\
*endif
*if(gendata(UserDefinedS1,int)!=0)
, UserDefSolid1*\
*endif
*if(gendata(UserDefinedS2,int)!=0)
, UserDefSolid2*\
*endif
*if(gendata(UserDefinedS3,int)!=0)
, UserDefSolid3*\
*endif
;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   Nodes, CoordinateUnits=*gendata(Geometry_Units);
*IntFormat "%i"
*RealFormat "%lf"
*loop nodes
  *Nodesnum  *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end nodes
*set var ElemType = 1
*set var NumTypes = 6
*set var nnodeprs = 6
*set var nnodetet = 4
*set var nnodehex = 8
*set var nnodetri = 3
*set var nnodequa = 4
*if(isQuadratic)
*if(nnode==11||nnode==27)
*set var nnodetet = 11
*set var nnodehex = 27
*set var nnodetri = 7
*set var nnodequa = 9
*else
*set var nnodetet = 10
*set var nnodehex = 20
*set var nnodetri = 6
*set var nnodequa = 8
*endif
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*if(strcmp(gendata(Solve_Fluid),"Yes")==0) 
 FluidDefinition: FlowModel = *gendata(FluidFlowModel), Integration_Scheme = *gendata(FTime_Integration), Assembling_Type = *gendata(Fluid_Assembling_Type)*\
*if(strcmp(gendata(Solve_FluidFlow_in_Fluid),"Yes")==0) 
, Solve_NavierStokes, MinTauV_Ratio = *gendata(StabTauV_MinRatio), MinTauP_Ratio = *gendata(StabTauP_MinRatio), Velocity_Smoothing = *gendata(Velocity_Control_Level), BodyTau_Ratio = *gendata(Movement_StabRatio)*\
*if(strcmp(gendata(Turbulence_Model),"Laminar")!=0) 
, Solve_*gendata(Turbulence_Model)*\
*endif 
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
, Solve_OddLevelSet, *gendata(ODDLS_Number_of_Phases)*\
*if(strcmp(gendata(ODDLS_VOF_Simplification),"On")==0)
, Solve_VolumeOfFluid*\
*endif 
*endif 
*if(strcmp(gendata(Solve_Transpiration_in_Fluid),"Yes")==0)
, Solve_Transpiration*\
*endif
, Turbulence_Smoothing = *gendata(Turbulence_Control_Level), EddyKEnergy_Production_Limit = *gendata(EddyKEnergy_Production_Limit), Epsilon_Production_Limit = *gendata(Epsilon_Production_Limit), Epsilon_Reaction_Limit = *gendata(Epsilon_Reaction_Limit), Omega_Production_Limit = *gendata(Omega_Production_Limit), Omega_Reaction_Limit = *gendata(Omega_Reaction_Limit), EddyViscoT_Production_Limit = *gendata(EddyViscoT_Production_Limit), EddyViscoT_Reaction_Limit = *gendata(EddyViscoT_Reaction_Limit), TVscMinimum = *gendata(TVisco_Min_Ratio), TVscMaximum = *gendata(TVisco_Max_Ratio), KenrMinimum = *gendata(KEnergy_Min_Ratio), KenrMaximum = *gendata(KEnergy_Max_Ratio), EpslMinimum = *gendata(Epsilon_Min_Ratio), EpslMaximum = *gendata(Epsilon_Max_Ratio), OmegMinimum = *gendata(Omega_Min_Ratio), OmegMaximum = *gendata(Omega_Max_Ratio), KtauMinimum = *gendata(K_Tau_Min_Ratio), KtauMaximum = *gendata(K_Tau_Max_Ratio), NS_AdvecStab_*gendata(Velocity_Advect_Stabilisation), NS_PressStab_*gendata(Pressure_Stabilisation), TB_AdvecStab_*gendata(Turbulence_Advect_Stabilisation), SteadyNorm = *gendata(FLUIDSOLVER_Steady_State_Norm), AdvectionNorm = *gendata(Advection_Norm), Control_Increment = *gendata(FLUIDSOLVER_Increment_Control), Calculate_Tau_Type = *gendata(Calculate_Tau_Type)*\ 
*if(strcmp(gendata(Fix_Turbulence_On_Bodies),"Yes")==0) 
, FixTurbulenceOnBodies *\
*elseif(strcmp(gendata(Fix_Turbulence_On_Bodies),"OnlyK")==0)
, FixKEnergyOnBodies *\
*elseif(strcmp(gendata(Fix_Turbulence_On_Bodies),"FreeK")==0)
, FreeKEnergyOnBodies *\
*endif 
*endif 
*if(strcmp(gendata(Solve_Temperature_in_Fluid),"Yes")==0)
, Solve_Temperature, Temperature_Smoothing = *gendata(Temperature_Control_Level), TM_AdvecStab_*gendata(Temperature_Advect_Stabilisation), Prandtl_Number = *gendata(Prandtl_Number)*\
*endif
*if(strcmp(gendata(Solve_Compressibility_in_Fluid),"Yes")==0)
, Solve_Compressibility*\
*endif
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0)
, Solve_PhiProblems*\
*endif
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0)
, Solve_Concentration*\
*endif
*if(strcmp(gendata(Solve_Fluid_Shell_Coupling),"Yes")==0)
, Solve_Mesh_Deformation, MeshDeformationType = ByShellCoupling, MeshDeformationLoadType = Vector, UpdateMeshEvery = 1*\
*else
*if(strcmp(gendata(Solve_MeshDeformation_in_Fluid),"Yes")==0)
, Solve_Mesh_Deformation, MeshDeformationType = *gendata(Fluid_Mesh_Deformation)*\
*if(gendata(FluidUpdateMeshEvery,int)>1) 
, UpdateMeshEvery = *gendata(FluidUpdateMeshEvery)*\
*endif
*endif
*endif
;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*9+1
 NewSpecDefinition: Index = *iphi, Name = "*gendata(Species_Names,*iphi)", MaxLimit = *gendata(Advect_Solverdata,*coun), MinLimit = *gendata(Advect_Solverdata,*operation(coun+1)), Schmidt_Number = *gendata(Advect_Solverdata,*operation(coun+2)), Convergence_Norm = *gendata(Advect_Solverdata,*operation(coun+3)), InnerIterations = *gendata(Advect_Solverdata,*operation(coun+4)), AdvecStab_*gendata(Advect_Solverdata,*operation(coun+5)), Phi_Smoothing = *gendata(Advect_Solverdata,*operation(coun+6)), Mass_Conservation = *gendata(Advect_Solverdata,*operation(coun+7)), Boundary_Units = [*gendata(Advect_Solverdata,*operation(coun+8))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*9+1
 NewPhiDefinition: Index = *iphi, Name = "*gendata(URVariables_Names,*iphi)", MaxLimit = *gendata(URSolver_Solverdata,*coun), MinLimit = *gendata(URSolver_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(URSolver_Solverdata,*operation(coun+2)), InnerIterations = *gendata(URSolver_Solverdata,*operation(coun+3)), AdvecStab_*gendata(URSolver_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(URSolver_Solverdata,*operation(coun+5)), Mass_Conservation = *gendata(URSolver_Solverdata,*operation(coun+6)), Iter_Reinitialisation = *gendata(URSolver_Solverdata,*operation(coun+7)), Boundary_Units = [*gendata(URSolver_Solverdata,*operation(coun+8))];
*end
*endif 
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
 NewPhiDefinition: Index = 54321, Name = "OLS", MaxLimit = 1.0e50, MinLimit = -1.0e50, Convergence_Norm = *gendata(ODDLS_Norm), InnerIterations = 1, AdvecStab_*gendata(ODDLS_Advect_Stabilisation), Phi_Smoothing = *gendata(ODDLS_Control_Level), Iter_Reinitialisation = 1, Boundary_Units = [U]*\
*if(strcmp(gendata(Initiate_OddLevelSet),"No")==0)
, No_Initiate*\
*endif
*if(strcmp(gendata(ODDLS_Mass_Conservation),"On")==0)
, Mass_Conservation = 1,
*elseif(strcmp(gendata(ODDLS_Mass_Conservation),"Fixed")==0)
, Mass_Conservation = 1, Mass_Increment = *gendata(ODDLS_Mass_Increment) *gendata(ODDLS_Mass_Increment_Units)
*endif
;
*endif 
InitialDataFunctions;
    Function VelocityX = "*gendata(Initial_VelocityX);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(Initial_VelocityY);" *gendata(Boundary_Velocity_Units);
    Function VelocityZ = "*gendata(Initial_VelocityZ);" *gendata(Boundary_Velocity_Units);
    Function Pressure = "*gendata(Initial_Pressure);"  *gendata(Boundary_Pressure_Units);
    Function EddyKineticEnergy = "*gendata(Initial_EddyKEner);" *gendata(Boundary_Kenr_Units);
    Function EddyLength = "*gendata(Initial_EddyLength);" *gendata(Boundary_Elen_Units);
    Function Temperature = "*gendata(Initial_Temperature);" *gendata(Boundary_Temperature_Units);
EndInitialDataFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesInitialData *iphi = "*tcl(TdynOutput::Genlist Advect_Initdata *operation(2*(iphi-1)+1));" [*tcl(TdynOutput::Genlist Advect_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableInitialData *iphi = "*tcl(TdynOutput::Genlist URSolver_Initdata *operation(2*(iphi-1)+1));" [*tcl(TdynOutput::Genlist URSolver_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
    VariableInitialData 54321 = "*gendata(Initial_OddLevelSet);" [U];
*endif 
ConditionalFunctions;
    Function VelocityX = "*gendata(VelocityX_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(VelocityY_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityZ = "*gendata(VelocityZ_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function Pressure  = "*gendata(Pressure_FuncCond);"  *gendata(Boundary_Pressure_Units);
    Function Temperature  = "*gendata(Temperature_FuncCond);"  *gendata(Boundary_Temperature_Units);
EndConditionalFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesConditional *iphi = "*tcl(TdynOutput::Genlist Advect_Initdata *operation(2*(iphi-1)+2));" [*tcl(TdynOutput::Genlist Advect_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableConditional *iphi = "*tcl(TdynOutput::Genlist URSolver_Initdata *operation(2*(iphi-1)+2));" [*tcl(TdynOutput::Genlist URSolver_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
    VariableConditional 54321 = "*gendata(OddLevelSet_FuncCond);" [U];
*endif 
*if(strcmp(gendata(Solve_MeshDeformation_in_Fluid),"Yes")==0) 
 MeshDeformationFunctions: 
    MeshDeformationX = "*gendata(Fluid_Deformation_X);" *gendata(Geometry_Units),
    MeshDeformationY = "*gendata(Fluid_Deformation_Y);" *gendata(Geometry_Units),
    MeshDeformationZ = "*gendata(Fluid_Deformation_Z);" *gendata(Geometry_Units);
*endif 
*if(strcmp(gendata(UserIntegralF1),"0")!=0 || strcmp(gendata(UserIntegralS2),"0")!=0 || strcmp(gendata(UserIntegralS3),"0")!=0) 
IntegralFunctions:
    Integral1 = "*gendata(UserIntegralF1);" [],
    Integral2 = "*gendata(UserIntegralF2);" [],
    Integral3 = "*gendata(UserIntegralF3);" [];
*endif 
*if(gendata(UserDefinedF1,int)!=0 || gendata(UserDefinedF2,int)!=0 || gendata(UserDefinedF3,int)!=0) 
 CustomisedResultsFunctions;
*if(gendata(UserDefinedF1,int)!=0)
    CustomRes = "*gendata(FluidFunction1);", Name = "*gendata(FluidFunction1_Name)";
*endif
*if(gendata(UserDefinedF2,int)!=0)
    CustomRes = "*gendata(FluidFunction2);", Name = "*gendata(FluidFunction2_Name)";
*endif
*if(gendata(UserDefinedF3,int)!=0)
    CustomRes = "*gendata(FluidFunction3);", Name = "*gendata(FluidFunction3_Name)";
*endif
 EndCustomisedResultsFunctions;
*endif 
 NonSymmetric "Fluid 1st Solver": Solver = *gendata(FSolver_NonSymmetric), Tolerance = *gendata(NS1_Tolerance), Max_Iter = *gendata(NS1_MaxIter), Preconditioner = *gendata(NS1_Preconditioner)*\
*if(strcmp(gendata(FSolver_NonSymmetric),"GMRes")==0)
, Kdim = *gendata(NS1_Kdim)
*endif 
;
 Symmetric "Fluid 2nd Solver": Solver = *gendata(FSolver_Symmetric), Tolerance = *gendata(NS2_Tolerance), Max_Iter = *gendata(NS2_MaxIter), Preconditioner = *gendata(NS2_Preconditioner)*\
*if(strcmp(gendata(FSolver_Symmetric),"GMRes")==0)
, Kdim = *gendata(NS2_Kdim)
*endif 
;
  ElmSets;
*set var MatNumber = 1
*loop Materials 
*if(strcmp(MatProp(Type),"Fluid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==4 || ElemType==5 || ElemType==6) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
Set *MatNumber:  Type = Fluid, Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode, FluidModel = *MatProp(Equation_Of_State);
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
	SpeciesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "F1 F2 F3 F4 F5" Species_Properties Spc_Units "0 1 2 3 4" 9)
	EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0 || strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
	VariablesProperties;
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0)
*tcl(TdynOutput::FormatMatlist *MatProp(0) "F1t F1c F2 F3 F4" Variables_Properties URV_Units "" 9)
*endif
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
         Index 54321, F1t = "1.0;" [1/m3], F1c = "1.0;" [1/m3], F2 = "0.0;" [1/m.s], F3 = "0.0;" [1/m3.s], F4 = "0.0;" [U/m3.s];
*endif 
	EndVariablesProperties;
*endif 
		  PhysicalPropertiesFunctions;  ! Data fields given as functions
                    Function AccelerationX = "*MatProp(AccOX_Field);"  *MatProp(Acceleration_Units);
		    Function AccelerationY = "*MatProp(AccOY_Field);"  *MatProp(Acceleration_Units);
                    Function AccelerationZ = "*MatProp(AccOZ_Field);"  *MatProp(Acceleration_Units);
                    Function ReactiveAccelX = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) X);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
		    Function ReactiveAccelY = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) Y);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
                    Function ReactiveAccelZ = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) Z);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
		    Function HeatSource = "*MatProp(Heat_Source_Field);" *MatProp(Heat_Source_Units);
                    Function HeatSourceReaction = "*MatProp(Heat_Reaction_Field);" *MatProp(Heat_Reaction_Units);
		    Function SurfaceTension = "*MatProp(Surface_Tension);" *MatProp(Surface_Tension_Units); 
*if(strcmp(gendata(ODDLS_Number_of_Phases),"Two_Phases")==0 & strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0)
		    Function Viscosity = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Viscosity);" *MatProp(Viscosity_Units);
		    Function Density = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Density);" *MatProp(Density_Units);
		    Function Compressibility = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Compressibility);" *MatProp(Compressibility_Units);
                    Function MolarMass = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Molar_Mass);" *MatProp(Molar_Mass_Units);
		    Function SpecificHeat = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Specific_Heat_Cp);"  *MatProp(Cp_Units);
		    Function Conductivity = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Thermal_Conductivity_k);" *MatProp(k_Units); 
		    Function Floatability = "*tcl(TdynOutput::ODDLSField *MatProp(0) *MatProp(Secondary_Phase) Floatability);" [];
*else
		    Function Viscosity = "*MatProp(Viscosity);" *MatProp(Viscosity_Units);
		    Function Density = "*MatProp(Density);" *MatProp(Density_Units);
		    Function Compressibility = "*MatProp(Compressibility);" *MatProp(Compressibility_Units);
                    Function MolarMass = "*MatProp(Molar_Mass);" *MatProp(Molar_Mass_Units);
		    Function SpecificHeat = "*MatProp(Specific_Heat_Cp);"  *MatProp(Cp_Units);
		    Function Conductivity = "*MatProp(Thermal_Conductivity_k);" *MatProp(k_Units); 
		    Function Floatability = "*MatProp(Floatability);" [];
*endif
		  EndPhysicalPropertiesFunctions;
		Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"Wall_in_Fluid")==0 || strcmp(MatProp(Type),"Inlet_in_Fluid")==0 || strcmp(MatProp(Type),"Outlet_in_Fluid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==2 || ElemType==3) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = WBody,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,
*if(MatProp(Body_Mass_Auto,int))
		      Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units), Auto_Body_Mass,
*else
		      Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units),
*endif
		      MovementRelaxation = *MatProp(Movement_Relaxation), MovementDamping = *MatProp(Movement_Damping)
                      Center_of_Gravity: GOX = "*MatProp(Centre_of_Gravity_X);" *gendata(Geometry_Units), GOY = "*MatProp(Centre_of_Gravity_Y);" *gendata(Geometry_Units), GOZ = "*MatProp(Centre_of_Gravity_Z);" *gendata(Geometry_Units),
                      Radii_of_Gyration = *MatProp(Radius_of_Gyration_X) *MatProp(Radius_of_Gyration_Y) *MatProp(Radius_of_Gyration_Z) *gendata(Geometry_Units),
		      External_Forces: 
                       EForX = "*MatProp(EForce_OX);" *gendata(Boundary_Force_Units), EForY = "*MatProp(EForce_OY);" *gendata(Boundary_Force_Units), EForZ = "*MatProp(EForce_OZ);" *gendata(Boundary_Force_Units),
                       EMomX = "*MatProp(EMoment_OX);" *gendata(Boundary_Moment_Units), EMomY = "*MatProp(EMoment_OY);" *gendata(Boundary_Moment_Units), EMomZ = "*MatProp(EMoment_OZ);" *gendata(Boundary_Moment_Units),
		      Displacement_OX = *\
*if(strcmp(MatProp(Shell_Coupling),"Yes")==0)
4*\
*else
*if(strcmp(MatProp(Displacement_OX),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OX),"Free")==0)
1, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OX),"Fixed")==0)
2, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OX),"Field")==0)
3, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*endif
*endif
, Displacement_OY = *\
*if(strcmp(MatProp(Shell_Coupling),"Yes")==0)
4*\
*else
*if(strcmp(MatProp(Displacement_OY),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OY),"Free")==0)
1, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OY),"Fixed")==0)
2, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OY),"Field")==0)
3, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*endif
*endif
, Displacement_OZ = *\
*if(strcmp(MatProp(Shell_Coupling),"Yes")==0)
4*\
*else
*if(strcmp(MatProp(Displacement_OZ),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OZ),"Free")==0)
1, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OZ),"Fixed")==0)
2, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OZ),"Field")==0)
3, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*endif
*endif
, Rotation_OX = *\
*if(strcmp(MatProp(Rotation_OX),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OX),"Free")==0)
1, ROX = "*MatProp(Rotation_Value_OX);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OX),"Fixed")==0)
2, ROX = "*MatProp(Rotation_Value_OX);" *gendata(Boundary_Angle_Units)*\
*endif
, Rotation_OY = *\
*if(strcmp(MatProp(Rotation_OY),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OY),"Free")==0)
1, ROY = "*MatProp(Rotation_Value_OY);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OY),"Fixed")==0)
2, ROY = "*MatProp(Rotation_Value_OY);" *gendata(Boundary_Angle_Units)*\
*endif
, Rotation_OZ = *\
*if(strcmp(MatProp(Rotation_OZ),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OZ),"Free")==0)
1, ROZ = "*MatProp(Rotation_Value_OZ);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OZ),"Fixed")==0)
2, ROZ = "*MatProp(Rotation_Value_OZ);" *gendata(Boundary_Angle_Units)*\
*endif
*if(MatProp(Sharp_Angle,real)>0)
, Sharp_Angle = *MatProp(Sharp_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if(MatProp(Fix_Angle,real)>0)
, Line_Fix_Angle = *MatProp(Fix_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if(MatProp(SternC_Angle,real)>0)
, SternC_Angle = *MatProp(SternC_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if((strcmp(MatProp(BoundType),"RoughWall")==0))
, RoughWall, Delta = *MatProp(Delta) *MatProp(Delta_Units), Roughness = *MatProp(Roughness) *MatProp(Roughness_Units) *\ 
*elseif((strcmp(MatProp(BoundType),"DeltaWall")==0))
, DeltaWall, Delta = *MatProp(Delta) *MatProp(Delta_Units) *\
*elseif((strcmp(MatProp(BoundType),"YplusWall")==0))
, YplusWall, Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"Cw_U2Wall")==0))
, Cw_U2Wall, Cw = *MatProp(Cw), *\
*elseif((strcmp(MatProp(BoundType),"ITTC_Wall")==0))
, ITTC_Wall, Cw = *MatProp(Cw), Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"User_Wall")==0))
, User_Wall, User_U_t = "*MatProp(FTau_Field);" *gendata(Boundary_Velocity_Units), User_Ken = "*MatProp(Kenr_Field);" *gendata(Boundary_Kenr_Units), User_Len = "*MatProp(ELen_Field);" *gendata(Boundary_Elen_Units)*\
*elseif((strcmp(MatProp(BoundType),"InvisWall")==0))
, InvisWall *\
*elseif((strcmp(MatProp(BoundType),"V_fixWall")==0))
, V_fixWall *\
*elseif((strcmp(MatProp(BoundType),"None_Wall")==0))
, None_Wall *\
*elseif((strcmp(MatProp(BoundType),"Inlet_Velc")==0))
, Inlet_Velc, User_Ux = "*MatProp(VelX_Field);" *gendata(Boundary_Velocity_Units), User_Uy = "*MatProp(VelY_Field);" *gendata(Boundary_Velocity_Units), User_Uz = "*MatProp(VelZ_Field);" *gendata(Boundary_Velocity_Units)*\
*elseif((strcmp(MatProp(BoundType),"Inlet_VelN")==0))
, Inlet_VelN, User_Un = "*MatProp(VelN_Field);" *gendata(Boundary_Velocity_Units)*\
*elseif((strcmp(MatProp(BoundType),"Inlet_Pres")==0))
, Inlet_Pres, User_Pr = "*MatProp(Pres_Field);" *gendata(Boundary_Pressure_Units)*\
*elseif((strcmp(MatProp(BoundType),"Outlet")==0))
, OutletPres, User_Pr = "*MatProp(Pres_Field);" *gendata(Boundary_Pressure_Units)*\
*endif
; 
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
		      SpeciesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "Flux_Spc Reac_Spc" Species_Properties Spc_Units "" 23)
		      EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0 || strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
		      VariablesProperties;
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0)
*tcl(TdynOutput::FormatMatlist *MatProp(0) "Flux_Phi Reac_Phi" Variables_Properties URV_Units "" 23)
*endif
*if(strcmp(gendata(Solve_OddLevelSet_in_Fluid),"Yes")==0) 
                       Index 54321, Flux_Phi = "0.0;" [U/m2.s], Reac_Phi = "0.0;" [1/m2.s];
*endif
		      EndVariablesProperties;
*endif 
		      PhysicalPropertiesFunctions;  ! Data fields given as functions
		       Function HeatFlux = "*MatProp(Heat_Flux);" *MatProp(Heat_Flux_Units);
		       Function HeatFluxReaction = "*MatProp(Reactive_Heat_Flux);" *MatProp(Reactive_Heat_Flux_Units);
		      EndPhysicalPropertiesFunctions;
		      Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
		*ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"FreeS")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1) 
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif 
*if(ElemType==2 || ElemType==3) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = FreeS,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,

		       Charact_Length = *MatProp(Length) *MatProp(Length_units), Damping_length = *MatProp(Damping_length), 
		       Damping_factor = *MatProp(Damping_factor), Time_factor = *MatProp(Time_factor), Time_ratio = *MatProp(Step_factor),
		       MinTau_Ratio = *MatProp(StabTau_MinRatio), Integration_Scheme = *MatProp(Time_Integration), Beta_Smoothing = *MatProp(Control_Level)*\
		       MaxValue = *MatProp(Maximum_Value), MinValue = *MatProp(Minimum_Value), FS_AdvecStab_*MatProp(Advect_Stabilisation)*\
*if(strcmp(MatProp(CrossWind_Diffusion),"On")==0) 
, CrossWind_Diffusion*\
*endif 
;
	       Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*endif 
*end 
  EndElmSets;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   BoundaryConditions;
    Units: Velocity=*gendata(Boundary_Velocity_Units),
	   Pressure=*gendata(Boundary_Pressure_Units),
	   Temperature=*gendata(Boundary_Temperature_Units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Coordinate Planes Symmetry
*if((strcmp(gendata(Xplane_Symmetry_in_Fluid),"Yes")==0))
   Xplane_VSym *gendata(Xplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Yplane_Symmetry_in_Fluid),"Yes")==0))
   Yplane_VSym *gendata(Yplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Zplane_Symmetry_in_Fluid),"Yes")==0))
   Zplane_VSym *gendata(Zplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!  Fix Pressure Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Pressure         *nodes
*add Cond Volume_Fix_Pressure  *nodes
*add Cond Surface_Fix_Pressure *nodes        
*add Cond Line_Fix_Pressure    *nodes        
*add Cond Point_Fix_Pressure   *nodes
*loop nodes *OnlyInCond
*format " Node %i :Pres = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Direction  !!!!!!!!!!!!!!!
*set Cond Surface_Fix_Velocity_Direction *nodes 
*add Cond Line_Fix_Velocity_Direction *nodes 
*add Cond Point_Fix_Velocity_Direction *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(1) *LocalAxesDef(4) *LocalAxesDef(7);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(2) *LocalAxesDef(5) *LocalAxesDef(8);
*else
 Node *NodesNum : LVel *LocalAxesDef(3) *LocalAxesDef(6) *LocalAxesDef(9);
*endif
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Velocity         *nodes *or(1,int) *or(3,int) *or(5,int)
*add Cond Volume_Fix_Velocity  *nodes *or(1,int) *or(3,int) *or(5,int)
*add Cond Surface_Fix_Velocity *nodes *or(1,int) *or(3,int) *or(5,int)
*Add Cond Line_Fix_Velocity    *nodes
*Add Cond Point_Fix_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Velc  %.5lf %.5lf %.5lf , Fix %i %i %i;"
  *NodesNum *cond(2) *cond(4) *cond(6) *cond(1) *cond(3) *cond(5)
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Component  !!!!!!!!!!!!!!!
*set Cond Surface_Fix_Velocity_Component *nodes 
*add Cond Line_Fix_Velocity_Component *nodes 
*add Cond Point_Fix_Velocity_Component *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(1) *LocalAxesDef(4) *LocalAxesDef(7), lVl = *cond(3);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(2) *LocalAxesDef(5) *LocalAxesDef(8), lVl = *cond(3);
*else
 Node *NodesNum : Norm *LocalAxesDef(3) *LocalAxesDef(6) *LocalAxesDef(9), lVl = *cond(3);
*endif
*end
!!!!!!!!!!!!!!!     Remove_Velocity      !!!!!!!!!!!!!!!
*set Cond Line_Remove_Velocity_Conditions  *nodes
*add Cond Point_Remove_Velocity_Conditions *nodes
*loop nodes *OnlyInCond
*if(fabs(cond(real,1)))
*format " Node %i, Delt;"
  *NodesNum
*endif
*end
!!!!!!!!!!!!!!!     Velocity Field       !!!!!!!!!!!!!!!
*set Cond Velocity_Field          *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*add Cond Volume_Velocity_Field   *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*add Cond Surface_Velocity_Field  *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*Add Cond Line_Velocity_Field     *nodes
*Add Cond Point_Velocity_Field    *nodes
*loop nodes *OnlyInCond
*format " Node %i : TVel %i %i %i %i %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3) *cond(4) *cond(5) *cond(6)
*end
!!!!!!!!!!!!!!!   Conditional Velocity   !!!!!!!!!!!!!!!
*set Cond Conditional_Velocity          *nodes
*add Cond Volume_Conditional_Velocity   *nodes
*add Cond Surface_Conditional_Velocity  *nodes
*Add Cond Line_Conditional_Velocity     *nodes
*Add Cond Point_Conditional_Velocity    *nodes
*loop nodes *OnlyInCond
 Node *NodesNum : CondVel;
*end
!!!!!!!!!!!!!!!     Pressure Field       !!!!!!!!!!!!!!!
*set Cond Pressure_Field         *nodes
*add Cond Volume_Pressure_Field  *nodes
*add Cond Surface_Pressure_Field *nodes
*Add Cond Line_Pressure_Field    *nodes
*Add Cond Point_Pressure_Field   *nodes
*loop nodes *OnlyInCond
*format " Node %i : TPres %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!    Conditional Pressure    !!!!!!!!!!!!!!
*set Cond  Conditional_Pressure        *nodes
*add Cond Volume_Conditional_Pressure *nodes
*add Cond Surface_Conditional_Pressure *nodes
*add Cond Line_Conditional_Pressure    *nodes
*add Cond Point_Conditional_Pressure   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondPres;
*end
!!!!!!!!!!!!!!!     Fix Temperature      !!!!!!!!!!!!!!!
*set Cond Fix_Temperature         *nodes
*add Cond Volume_Fix_Temperature *nodes        
*add Cond Surface_Fix_Temperature *nodes                
*Add Cond Line_Fix_Temperature    *nodes        
*Add Cond Point_Fix_Temperature   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Temp = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!    Temperature Field     !!!!!!!!!!!!!!!
*set Cond  Temperature_Field        *nodes
*add Cond Volume_Temperature_Field *nodes
*add Cond Surface_Temperature_Field *nodes
*add Cond Line_Temperature_Field    *nodes
*add Cond Point_Temperature_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TTemp %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional Temperature   !!!!!!!!!!!!!!
*set Cond  Conditional_Temperature        *nodes
*add Cond Volume_Conditional_Temperature *nodes
*add Cond Surface_Conditional_Temperature *nodes
*add Cond Line_Conditional_Temperature    *nodes
*add Cond Point_Conditional_Temperature   *nodes 
*loop nodes *OnlyInCond
  Node *NodesNum : CondTemp;
*end
!!!!!!!!!!!!!!!   Fix Odd Level Set    !!!!!!!!!!!!!!!
*set Cond Fix_ODDLS         *nodes
*add Cond Volume_Fix_ODDLS *nodes        
*add Cond Surface_Fix_ODDLS *nodes                
*Add Cond Line_Fix_ODDLS    *nodes        
*Add Cond Point_Fix_ODDLS   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : OddLSF = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Odd Level Set Field   !!!!!!!!!!!!!!!
*set Cond  ODDLS_Field        *nodes
*add Cond Volume_ODDLS_Field *nodes
*add Cond Surface_ODDLS_Field *nodes
*add Cond Line_ODDLS_Field    *nodes
*add Cond Point_ODDLS_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TOddLSF %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!! Conditional Odd Level Set !!!!!!!!!!!!!
*set Cond  Conditional_ODDLS        *nodes
*add Cond Volume_Conditional_ODDLS *nodes
*add Cond Surface_Conditional_ODDLS *nodes
*add Cond Line_Conditional_ODDLS    *nodes
*add Cond Point_Conditional_ODDLS   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondOddLSF;
*end
!!!!!!!!!!!!!!!    Fix Concentration     !!!!!!!!!!!!!!!
*set Cond Fix_Concentration         *nodes
*add Cond Volume_Fix_Concentration *nodes        
*add Cond Surface_Fix_Concentration *nodes                
*Add Cond Line_Fix_Concentration    *nodes        
*Add Cond Point_Fix_Concentration   *nodes
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, Conc = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!   Concentration Field    !!!!!!!!!!!!!!!
*set Cond  Concentration_Field        *nodes
*add Cond Volume_Concentration_Field *nodes
*add Cond Surface_Concentration_Field *nodes
*add Cond Line_Concentration_Field    *nodes
*add Cond Point_Concentration_Field   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, TConc %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!! Conditional Concentration  !!!!!!!!!!!!!!
*set Cond  Conditional_Concentration        *nodes
*add Cond Volume_Conditional_Concentration *nodes
*add Cond Surface_Conditional_Concentration *nodes
*add Cond Line_Conditional_Concentration    *nodes
*add Cond Point_Conditional_Concentration   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondConc;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!     Fix PhiVariable      !!!!!!!!!!!!!!!
*set Cond Fix_Variable         *nodes
*add Cond Volume_Fix_Variable *nodes        
*add Cond Surface_Fix_Variable *nodes                
*Add Cond Line_Fix_Variable    *nodes        
*Add Cond Point_Fix_Variable   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, Phi = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!    PhiVariable Field     !!!!!!!!!!!!!!!
*set Cond  Variable_Field        *nodes
*add Cond Volume_Variable_Field *nodes
*add Cond Surface_Variable_Field *nodes
*add Cond Line_Variable_Field    *nodes
*add Cond Point_Variable_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, TPhi %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!!     Conditional Phi        !!!!!!!!!!!!!!
*set Cond  Conditional_Variable        *nodes
*add Cond Volume_Conditional_Variable *nodes
*add Cond Surface_Conditional_Variable *nodes
*add Cond Line_Conditional_Variable    *nodes
*add Cond Point_Conditional_Variable   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondPhi;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!      Fix Turbulence      !!!!!!!!!!!!!!!
*set Cond  Fix_Turbulence         *nodes
*add Cond Volume_Fix_Turbulence *nodes
*add Cond Surface_Fix_Turbulence *nodes
*add Cond Line_Fix_Turbulence    *nodes
*add Cond Point_Fix_Turbulence   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Turb %i;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!         Fix Beta         !!!!!!!!!!!!!!!
*set Cond Fix_Beta         *nodes
*add Cond Surface_Fix_Beta *nodes                
*Add Cond Line_Fix_Beta    *nodes        
*Add Cond Point_Fix_Beta   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Beta = %i"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!! Fix_Mesh_Deformation_Condition !!!!!!!!!!!!
*set Cond Fix_Mesh_Deformation         *nodes
*add Cond Volume_Fix_Mesh_Deformation  *nodes
*add Cond Surface_Fix_Mesh_Deformation *nodes
*Add Cond Line_Fix_Mesh_Deformation    *nodes
*Add Cond Point_Fix_Mesh_Deformation   *nodes
*loop nodes *OnlyInCond
    Node *NodesNum : DMesh  *cond(1);
*end
!!!!!!!!!!!!!!!   Fix_Mesh_Velocity   !!!!!!!!!!!!!!!
*set Cond Fix_Mesh_Velocity         *nodes *or(1,int) *or(2,int) *or(3,int)
*add Cond Volume_Fix_Mesh_Velocity  *nodes *or(1,int) *or(2,int) *or(3,int)
*add Cond Surface_Fix_Mesh_Velocity *nodes *or(1,int) *or(2,int) *or(3,int)
*Add Cond Line_Fix_Mesh_Velocity    *nodes *or(1,int) *or(2,int) *or(3,int)
*Add Cond Point_Fix_Mesh_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : VMesh  Fix %i %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
   EndBoundaryConditions;
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*if(strcmp(gendata(Solve_Solid),"Yes")==0) 
 SolidDefinition: FlowModel = *gendata(SolidFlowModel), Integration_Scheme = *gendata(STime_Integration), Assembling_Type = *gendata(Solid_Assembling_Type)*\
*if(strcmp(gendata(Solve_FluidFlow_in_Solid),"Yes")==0) 
, Solve_Stokes, MinTauV_Ratio = *gendata(StabTauV_MinRatio), MinTauP_Ratio = *gendata(StabTauP_MinRatio), Velocity_Smoothing = *gendata(Velocity_Control_Level),  NS_AdvecStab_*gendata(Velocity_Advect_Stabilisation), NS_PressStab_*gendata(Pressure_Stabilisation), TB_AdvecStab_*gendata(Turbulence_Advect_Stabilisation), SteadyNorm = *gendata(FLUIDSOLVER_Steady_State_Norm), Control_Increment = *gendata(SOLIDSOLVER_Increment_Control)*\
*if(strcmp(gendata(Use_Total_Pressure),"Yes")==0) 
, Total_Pressure *\
*endif 
*endif 
*if(strcmp(gendata(Solve_Temperature_in_Solid),"Yes")==0)
, Solve_Temperature, Temperature_Smoothing = *gendata(Temperature_Control_Level), TM_AdvecStab_*gendata(Temperature_Advect_Stabilisation), Prandtl_Number = *gendata(Prandtl_Number)*\
*endif
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0)
, Solve_PhiProblems*\
*endif
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0)
, Solve_Concentration*\
*endif
*if(strcmp(gendata(Solve_MeshDeformation_in_Solid),"Yes")==0)
, Solve_Mesh_Deformation, MeshDeformationType = *gendata(Solid_Mesh_Deformation)*\
*if(gendata(SolidUpdateMeshEvery,int)>1) 
, UpdateMeshEvery = *gendata(SolidUpdateMeshEvery)*\
*endif
*endif
*if(strcmp(gendata(Solve_StructuralProblem_in_Solid),"Yes")==0) 
, Solve_RamSolid*\ 
*if(strcmp(gendata(Coupling_Type),"None")!=0) 
, Coupling_Type = *gendata(Coupling_Type), Coupling_Step = *gendata(Coupling_Step), Coupling_Start = *gendata(Coupling_Start)*\
*endif 
*endif 
;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*9+1
 NewSpecDefinition: Index = *iphi, Name = "*gendata(Species_Names,*iphi)", MaxLimit = *gendata(Advect_Solverdata,*coun), MinLimit = *gendata(Advect_Solverdata,*operation(coun+1)), Schmidt_Number = 0.0, Convergence_Norm = *gendata(Advect_Solverdata,*operation(coun+3)), InnerIterations = *gendata(Advect_Solverdata,*operation(coun+4)), AdvecStab_*gendata(Advect_Solverdata,*operation(coun+5)), Phi_Smoothing = *gendata(Advect_Solverdata,*operation(coun+6)), Mass_Conservation = *gendata(Advect_Solverdata,*operation(coun+7)), Boundary_Units = [*gendata(Advect_Solverdata,*operation(coun+8))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*9+1
 NewPhiDefinition: Index = *iphi, Name = "*gendata(URVariables_Names,*iphi)", MaxLimit = *gendata(URSolver_Solverdata,*coun), MinLimit = *gendata(URSolver_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(URSolver_Solverdata,*operation(coun+2)), InnerIterations = *gendata(URSolver_Solverdata,*operation(coun+3)), AdvecStab_*gendata(URSolver_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(URSolver_Solverdata,*operation(coun+5)), Mass_Conservation = *gendata(URSolver_Solverdata,*operation(coun+6)), Iter_Reinitialisation = *gendata(URSolver_Solverdata,*operation(coun+7)), Boundary_Units = [*gendata(URSolver_Solverdata,*operation(coun+8))];
*end
*endif 
InitialDataFunctions;
    Function VelocityX = "*gendata(Initial_VelocityX);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(Initial_VelocityY);" *gendata(Boundary_Velocity_Units);
    Function VelocityZ = "*gendata(Initial_VelocityZ);" *gendata(Boundary_Velocity_Units);
    Function Pressure = "*gendata(Initial_Pressure);"  *gendata(Boundary_Pressure_Units);
    Function EddyKineticEnergy = "*gendata(Initial_EddyKEner);" *gendata(Boundary_Kenr_Units);
    Function EddyLength = "*gendata(Initial_EddyLength);" *gendata(Boundary_Elen_Units);
    Function Temperature = "*gendata(Initial_Temperature);" *gendata(Boundary_Temperature_Units);
EndInitialDataFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesInitialData *iphi = "*tcl(TdynOutput::Genlist Advect_Initdata *operation(2*(iphi-1)+1));" [*tcl(TdynOutput::Genlist Advect_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableInitialData *iphi = "*tcl(TdynOutput::Genlist URSolver_Initdata *operation(2*(iphi-1)+1));" [*tcl(TdynOutput::Genlist URSolver_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
ConditionalFunctions;
    Function VelocityX = "*gendata(VelocityX_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(VelocityY_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityZ = "*gendata(VelocityZ_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function Pressure  = "*gendata(Pressure_FuncCond);"  *gendata(Boundary_Pressure_Units);
    Function Temperature  = "*gendata(Temperature_FuncCond);"  *gendata(Boundary_Temperature_Units);
EndConditionalFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesConditional *iphi = "*tcl(TdynOutput::Genlist Advect_Initdata *operation(2*(iphi-1)+2));" [*tcl(TdynOutput::Genlist Advect_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableConditional *iphi = "*tcl(TdynOutput::Genlist URSolver_Initdata *operation(2*(iphi-1)+2));" [*tcl(TdynOutput::Genlist URSolver_Solverdata *operation((iphi-1)*9+9))];
*end
*endif 
*if(strcmp(gendata(Solve_MeshDeformation_in_Solid),"Yes")==0) 
 MeshDeformationFunctions: 
    MeshDeformationX = "*gendata(Solid_Deformation_X);" *gendata(Geometry_Units),
    MeshDeformationY = "*gendata(Solid_Deformation_Y);" *gendata(Geometry_Units),
    MeshDeformationZ = "*gendata(Solid_Deformation_Z);" *gendata(Geometry_Units);
*endif 
*if(strcmp(gendata(UserIntegralS1),"0")!=0 || strcmp(gendata(UserIntegralS2),"0")!=0 || strcmp(gendata(UserIntegralS3),"0")!=0) 
IntegralFunctions:
    Integral1 = "*gendata(UserIntegralS1);" [],
    Integral2 = "*gendata(UserIntegralS2);" [],
    Integral3 = "*gendata(UserIntegralS3);" [];
*endif 
*if(gendata(UserDefinedS1,int)!=0 || gendata(UserDefinedS2,int)!=0 || gendata(UserDefinedS3,int)!=0) 
 CustomisedResultsFunctions;
*if(gendata(UserDefinedS1,int)!=0)
    CustomRes = "*gendata(SolidFunction1);", Name = "*gendata(SolidFunction1_Name)";
*endif
*if(gendata(UserDefinedS2,int)!=0)
    CustomRes = "*gendata(SolidFunction2);", Name = "*gendata(SolidFunction2_Name)";
*endif
*if(gendata(UserDefinedS3,int)!=0)
    CustomRes = "*gendata(SolidFunction3);", Name = "*gendata(SolidFunction3_Name)";
*endif
 EndCustomisedResultsFunctions;
*endif 
 NonSymmetric "Solid 1st Solver": Solver = *gendata(SSolver_Symmetric), Tolerance = *gendata(S_Tolerance), Max_Iter = *gendata(S_MaxIter), Preconditioner = *gendata(S_Preconditioner)*\
*if(strcmp(gendata(SSolver_Symmetric),"GMRes")==0)
, Kdim = *gendata(S_Kdim)
*endif 
;
 Symmetric "Solid 2nd Solver": Solver = *gendata(SSolver_Symmetric), Tolerance = *gendata(S_Tolerance), Max_Iter = *gendata(S_MaxIter), Preconditioner = *gendata(S_Preconditioner)*\
*if(strcmp(gendata(SSolver_Symmetric),"GMRes")==0)
, Kdim = *gendata(S_Kdim)
*endif 
;
  ElmSets;
*set var MatNumber = 1
*loop Materials 
*if(strcmp(MatProp(Type),"Solid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==4 || ElemType==5 || ElemType==6) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
Set *MatNumber:  Type = Solid, Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode, FluidModel = *MatProp(Equation_Of_State);
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
	SpeciesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "F1 F2xx F2xy F2xz F2yy F2yz F2zz F3 F4" Species_Properties Spc_Units "0 1 1 1 1 1 1 2 3" 9)
	EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
	VariablesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "F1 F2xx F2xy F2xz F2yx F2yy F2yz F2zx F2zy F2zz F3 F4" Variables_Properties URV_Units "1 2 2 2 2 2 2 2 2 2 3 4" 9)
	EndVariablesProperties;
*endif 
		  PhysicalPropertiesFunctions;  ! Data fields given as functions
                    Function AccelerationX = "*MatProp(AccOX_Field);"  *MatProp(Acceleration_Units);
		    Function AccelerationY = "*MatProp(AccOY_Field);"  *MatProp(Acceleration_Units);
                    Function AccelerationZ = "*MatProp(AccOZ_Field);"  *MatProp(Acceleration_Units);
                    Function ReactiveAccelX = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) X);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
		    Function ReactiveAccelY = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) Y);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
                    Function ReactiveAccelZ = "*tcl(TdynOutput::Mat_DarcyReaction *MatProp(0) Z);" [1/*tcl(TdynOutput::GiveUnits Internal_Time_units)];
		    Function HeatSource = "*MatProp(Heat_Source_Field);" *MatProp(Heat_Source_Units);
		    Function Viscosity = "*MatProp(Viscosity);" *MatProp(Viscosity_Units);
		    Function Density = "*MatProp(Fluid_Density);" *MatProp(Fluid_Density_Units);
                    Function Compressibility = "*MatProp(Compressibility);" *MatProp(Compressibility_Units);
                    Function MolarMass = "*MatProp(Molar_Mass);" *MatProp(Molar_Mass_Units);
		    Function SolidDensity = "*MatProp(Density);" *MatProp(Density_Units);
		    Function SpecificHeat = "*MatProp(Specific_Heat_C);"  *MatProp(C_Units);
		    Function ConductivityXX = "*MatProp(Thermal_Conductivity_k11);" *MatProp(k_Units); 
		    Function ConductivityXY = "*MatProp(Thermal_Conductivity_k12);" *MatProp(k_Units); 
            Function ConductivityXZ = "*MatProp(Thermal_Conductivity_k13);" *MatProp(k_Units); 
		    Function ConductivityYY = "*MatProp(Thermal_Conductivity_k22);" *MatProp(k_Units); 
            Function ConductivityYZ = "*MatProp(Thermal_Conductivity_k23);" *MatProp(k_Units); 
            Function ConductivityZZ = "*MatProp(Thermal_Conductivity_k33);" *MatProp(k_Units); 
		    Function Floatability = "*MatProp(Floatability);" [];                                 
		    Function HeatSourceReaction = "*MatProp(Heat_Reaction_Field);" *MatProp(Heat_Reaction_Units); 
            Function MechanicalStrain = "*MatProp(Mechanical_strain);" []; 
		  EndPhysicalPropertiesFunctions;
		Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"Wall_in_Solid")==0 || strcmp(MatProp(Type),"Inlet_in_Solid")==0 || strcmp(MatProp(Type),"Outlet_in_Solid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==2 || ElemType==3) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = WBody,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,
*if(MatProp(Body_Mass_Auto,int))
		      Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units), Auto_Body_Mass,
*else
		      Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units),
*endif
		      MovementRelaxation = *MatProp(Movement_Relaxation), MovementDamping = *MatProp(Movement_Damping)
                      Center_of_Gravity: GOX = "*MatProp(Centre_of_Gravity_X);" *gendata(Geometry_Units), GOY = "*MatProp(Centre_of_Gravity_Y);" *gendata(Geometry_Units), GOZ = "*MatProp(Centre_of_Gravity_Z);" *gendata(Geometry_Units),
                      Radii_of_Gyration = *MatProp(Radius_of_Gyration_X) *MatProp(Radius_of_Gyration_Y) *MatProp(Radius_of_Gyration_Z) *gendata(Geometry_Units),
		      External_Forces: 
                       EForX = "*MatProp(EForce_OX);" *gendata(Boundary_Force_Units), EForY = "*MatProp(EForce_OY);" *gendata(Boundary_Force_Units), EForZ = "*MatProp(EForce_OZ);" *gendata(Boundary_Force_Units),
                       EMomX = "*MatProp(EMoment_OX);" *gendata(Boundary_Moment_Units), EMomY = "*MatProp(EMoment_OY);" *gendata(Boundary_Moment_Units), EMomZ = "*MatProp(EMoment_OZ);" *gendata(Boundary_Moment_Units),
		      Displacement_OX = *\
*if(strcmp(MatProp(Displacement_OX),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OX),"Free")==0)
1, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OX),"Fixed")==0)
2, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OX),"Field")==0)
3, DOX = "*MatProp(Displacement_Value_OX);" *gendata(Geometry_Units)*\
*endif
, Displacement_OY = *\
*if(strcmp(MatProp(Displacement_OY),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OY),"Free")==0)
1, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OY),"Fixed")==0)
2, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OY),"Field")==0)
3, DOY = "*MatProp(Displacement_Value_OY);" *gendata(Geometry_Units)*\
*endif
, Displacement_OZ = *\
*if(strcmp(MatProp(Displacement_OZ),"None")==0)
0*\
*elseif(strcmp(MatProp(Displacement_OZ),"Free")==0)
1, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OZ),"Fixed")==0)
2, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*elseif(strcmp(MatProp(Displacement_OZ),"Field")==0)
3, DOZ = "*MatProp(Displacement_Value_OZ);" *gendata(Geometry_Units)*\
*endif
, Rotation_OX = *\
*if(strcmp(MatProp(Rotation_OX),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OX),"Free")==0)
1, ROX = "*MatProp(Rotation_Value_OX);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OX),"Fixed")==0)
2, ROX = "*MatProp(Rotation_Value_OX);" *gendata(Boundary_Angle_Units)*\
*endif
, Rotation_OY = *\
*if(strcmp(MatProp(Rotation_OY),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OY),"Free")==0)
1, ROY = "*MatProp(Rotation_Value_OY);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OY),"Fixed")==0)
2, ROY = "*MatProp(Rotation_Value_OY);" *gendata(Boundary_Angle_Units)*\
*endif
, Rotation_OZ = *\
*if(strcmp(MatProp(Rotation_OZ),"None")==0)
0*\
*elseif(strcmp(MatProp(Rotation_OZ),"Free")==0)
1, ROZ = "*MatProp(Rotation_Value_OZ);" *gendata(Boundary_Angle_Units)*\
*elseif(strcmp(MatProp(Rotation_OZ),"Fixed")==0)
2, ROZ = "*MatProp(Rotation_Value_OZ);" *gendata(Boundary_Angle_Units)*\
*endif
*if(MatProp(Sharp_Angle,real)>0)
, Sharp_Angle = *MatProp(Sharp_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if(MatProp(Fix_Angle,real)>0)
, Line_Fix_Angle = *MatProp(Fix_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if(MatProp(SternC_Angle,real)>0)
, SternC_Angle = *MatProp(SternC_Angle) *gendata(Boundary_Angle_Units) *\
*endif
*if((strcmp(MatProp(BoundType),"RoughWall")==0))
, RoughWall, Delta = *MatProp(Delta) *MatProp(Delta_Units), Roughness = *MatProp(Roughness) *MatProp(Roughness_Units) *\ 
*elseif((strcmp(MatProp(BoundType),"DeltaWall")==0))
, DeltaWall, Delta = *MatProp(Delta) *MatProp(Delta_Units) *\
*elseif((strcmp(MatProp(BoundType),"YplusWall")==0))
, YplusWall, Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"Cw_U2Wall")==0))
, Cw_U2Wall, Cw = *MatProp(Cw), *\
*elseif((strcmp(MatProp(BoundType),"ITTC_Wall")==0))
, ITTC_Wall, Cw = *MatProp(Cw), Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"User_Wall")==0))
, User_Wall, User_U_t = "*MatProp(FTau_Field);" *gendata(Boundary_Velocity_Units), User_Ken = "*MatProp(Kenr_Field);" *gendata(Boundary_Kenr_Units), User_Len = "*MatProp(ELen_Field);" *gendata(Boundary_Elen_Units)*\
*elseif((strcmp(MatProp(BoundType),"InvisWall")==0))
, InvisWall *\
*elseif((strcmp(MatProp(BoundType),"V_fixWall")==0))
, V_fixWall *\
*elseif((strcmp(MatProp(BoundType),"None_Wall")==0))
, None_Wall *\
*elseif((strcmp(MatProp(BoundType),"Inlet_Velc")==0))
, Inlet_Velc, User_Ux = "*MatProp(VelX_Field);" *gendata(Boundary_Velocity_Units), User_Uy = "*MatProp(VelY_Field);" *gendata(Boundary_Velocity_Units), User_Uz = "*MatProp(VelZ_Field);" *gendata(Boundary_Velocity_Units)*\
*elseif((strcmp(MatProp(BoundType),"Inlet_VelN")==0))
, Inlet_VelN, User_Un = "*MatProp(VelN_Field);" *gendata(Boundary_Velocity_Units)*\
*elseif((strcmp(MatProp(BoundType),"Inlet_Pres")==0))
, Inlet_Pres, User_Pr = "*MatProp(Pres_Field);" *gendata(Boundary_Pressure_Units)*\
*elseif((strcmp(MatProp(BoundType),"Outlet")==0))
, OutletPres, User_Pr = "*MatProp(Pres_Field);" *gendata(Boundary_Pressure_Units)*\
*endif
; 
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
		      SpeciesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "Flux_Spc Reac_Spc" Species_Properties Spc_Units "" 23)
		      EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
		      VariablesProperties;
*tcl(TdynOutput::FormatMatlist *MatProp(0) "Flux_Phi Reac_Phi" Variables_Properties URV_Units "" 23)
		      EndVariablesProperties;
*endif 
		      PhysicalPropertiesFunctions;  ! Data fields given as functions
		       Function HeatFlux = "*MatProp(Heat_Flux);" *MatProp(Heat_Flux_Units);
		       Function HeatFluxReaction = "*MatProp(Reactive_Heat_Flux);" *MatProp(Reactive_Heat_Flux_Units);
		      EndPhysicalPropertiesFunctions;
		      Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
		*ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"FreeS")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1) 
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif 
*if(ElemType==2 || ElemType==3) 
*set var WriteTitle = 1
*set var ElemNumber = 1
*IntFormat "%9i"
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = FreeS,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,

		       Charact_Length = *MatProp(Length) *MatProp(Length_units), Damping_length = *MatProp(Damping_length), 
		       Damping_factor = *MatProp(Damping_factor), Time_factor = *MatProp(Time_factor), Time_ratio = *MatProp(Step_factor),
		       MinTau_Ratio = *MatProp(StabTau_MinRatio), Integration_Scheme = *MatProp(Time_Integration), Beta_Smoothing = *MatProp(Control_Level)*\
		       MaxValue = *MatProp(Maximum_Value), MinValue = *MatProp(Minimum_Value), FS_AdvecStab_*MatProp(Advect_Stabilisation)*\
*if(strcmp(MatProp(CrossWind_Diffusion),"On")==0) 
, CrossWind_Diffusion*\
*endif 
;
	       Elements;
*set var MatNumber =operation(MatNumber+1)
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif 
*end 
*if(WriteTitle==0) 
		      end elements;
*endif 
*endif 
*end 
*endif 
*end 
  EndElmSets;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   BoundaryConditions;
    Units: Velocity=*gendata(Boundary_Velocity_Units),
	   Pressure=*gendata(Boundary_Pressure_Units),
	   Temperature=*gendata(Boundary_Temperature_Units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Coordinate Planes Symmetry
*if((strcmp(gendata(Xplane_Symmetry_in_Fluid),"Yes")==0))
   Xplane_VSym *gendata(Xplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Yplane_Symmetry_in_Fluid),"Yes")==0))
   Yplane_VSym *gendata(Yplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Zplane_Symmetry_in_Fluid),"Yes")==0))
   Zplane_VSym *gendata(Zplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!  Fix Pressure Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Pressure         *nodes
*add Cond Volume_Fix_Pressure  *nodes
*add Cond Surface_Fix_Pressure *nodes        
*add Cond Line_Fix_Pressure    *nodes        
*add Cond Point_Fix_Pressure   *nodes
*loop nodes *OnlyInCond
*format "    Node %i :Pres = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Direction  !!!!!!!!!!!!!!!
*set Cond Surface_Fix_Velocity_Direction *nodes 
*add Cond Line_Fix_Velocity_Direction *nodes 
*add Cond Point_Fix_Velocity_Direction *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(1) *LocalAxesDef(4) *LocalAxesDef(7);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(2) *LocalAxesDef(5) *LocalAxesDef(8);
*else
 Node *NodesNum : LVel *LocalAxesDef(3) *LocalAxesDef(6) *LocalAxesDef(9);
*endif
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Velocity         *nodes *or(1,int) *or(3,int) *or(5,int)
*add Cond Volume_Fix_Velocity  *nodes *or(1,int) *or(3,int) *or(5,int)
*add Cond Surface_Fix_Velocity *nodes *or(1,int) *or(3,int) *or(5,int)
*Add Cond Line_Fix_Velocity    *nodes
*Add Cond Point_Fix_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Velc  %.5lf %.5lf %.5lf , Fix %i %i %i;"
  *NodesNum *cond(2) *cond(4) *cond(6) *cond(1) *cond(3) *cond(5)
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Component  !!!!!!!!!!!!!!!
*set Cond Surface_Fix_Velocity_Component *nodes 
*add Cond Line_Fix_Velocity_Component *nodes 
*add Cond Point_Fix_Velocity_Component *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(1) *LocalAxesDef(4) *LocalAxesDef(7), lVl = *cond(3);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(2) *LocalAxesDef(5) *LocalAxesDef(8), lVl = *cond(3);
*else
 Node *NodesNum : Norm *LocalAxesDef(3) *LocalAxesDef(6) *LocalAxesDef(9), lVl = *cond(3);
*endif
*end
!!!!!!!!!!!!!!!     Remove_Velocity      !!!!!!!!!!!!!!!
*set Cond Line_Remove_Velocity_Conditions  *nodes
*add Cond Point_Remove_Velocity_Conditions *nodes
*loop nodes *OnlyInCond
*if(fabs(cond(real,1)))
*format "    Node %i, Delt;"
  *NodesNum
*endif
*end
!!!!!!!!!!!!!!!     Velocity Field       !!!!!!!!!!!!!!!
*set Cond Velocity_Field          *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*add Cond Volume_Velocity_Field   *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*add Cond Surface_Velocity_Field  *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int) *or(5,int) *or(6,int)
*Add Cond Line_Velocity_Field     *nodes
*Add Cond Point_Velocity_Field    *nodes
*loop nodes *OnlyInCond
*format "    Node %i : TVel %i %i %i %i %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3) *cond(4) *cond(5) *cond(6)
*end
!!!!!!!!!!!!!!!   Conditional Velocity   !!!!!!!!!!!!!!!
*set Cond Conditional_Velocity          *nodes
*add Cond Volume_Conditional_Velocity   *nodes
*add Cond Surface_Conditional_Velocity  *nodes
*Add Cond Line_Conditional_Velocity     *nodes
*Add Cond Point_Conditional_Velocity    *nodes
*loop nodes *OnlyInCond
 Node *NodesNum : CondVel;
*end
!!!!!!!!!!!!!!!     Pressure Field       !!!!!!!!!!!!!!!
*set Cond Pressure_Field         *nodes
*add Cond Volume_Pressure_Field  *nodes
*add Cond Surface_Pressure_Field *nodes
*Add Cond Line_Pressure_Field    *nodes
*Add Cond Point_Pressure_Field   *nodes
*loop nodes *OnlyInCond
*format " Node %i : TPres %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!    Conditional Pressure    !!!!!!!!!!!!!!
*set Cond  Conditional_Pressure        *nodes
*add Cond Volume_Conditional_Pressure *nodes
*add Cond Surface_Conditional_Pressure *nodes
*add Cond Line_Conditional_Pressure    *nodes
*add Cond Point_Conditional_Pressure   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondPres;
*end
!!!!!!!!!!!!!!!     Fix Temperature      !!!!!!!!!!!!!!!
*set Cond Fix_Temperature         *nodes
*add Cond Volume_Fix_Temperature *nodes        
*add Cond Surface_Fix_Temperature *nodes                
*Add Cond Line_Fix_Temperature    *nodes        
*Add Cond Point_Fix_Temperature   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Temp = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!    Temperature Field     !!!!!!!!!!!!!!!
*set Cond  Temperature_Field        *nodes
*add Cond Volume_Temperature_Field *nodes
*add Cond Surface_Temperature_Field *nodes
*add Cond Line_Temperature_Field    *nodes
*add Cond Point_Temperature_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TTemp %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional Temperature   !!!!!!!!!!!!!!
*set Cond  Conditional_Temperature        *nodes
*add Cond Volume_Conditional_Temperature *nodes
*add Cond Surface_Conditional_Temperature *nodes
*add Cond Line_Conditional_Temperature    *nodes
*add Cond Point_Conditional_Temperature   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondTemp;
*end
!!!!!!!!!!!!!!!   Fix Odd Level Set    !!!!!!!!!!!!!!!
*set Cond Fix_OddLS         *nodes
*add Cond Volume_Fix_OddLS *nodes        
*add Cond Surface_Fix_OddLS *nodes                
*Add Cond Line_Fix_OddLS    *nodes        
*Add Cond Point_Fix_OddLS   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : OddLSF = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Odd Level Set Field   !!!!!!!!!!!!!!!
*set Cond  OddLS_Field        *nodes
*add Cond Volume_OddLS_Field *nodes
*add Cond Surface_OddLS_Field *nodes
*add Cond Line_OddLS_Field    *nodes
*add Cond Point_OddLS_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TOddLSF %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!! Conditional Odd Level Set !!!!!!!!!!!!!
*set Cond  Conditional_OddLS        *nodes
*add Cond Volume_Conditional_OddLS *nodes
*add Cond Surface_Conditional_OddLS *nodes
*add Cond Line_Conditional_OddLS    *nodes
*add Cond Point_Conditional_OddLS   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondOddLSF;
*end
!!!!!!!!!!!!!!!    Fix Concentration     !!!!!!!!!!!!!!!
*set Cond Fix_Concentration         *nodes
*add Cond Volume_Fix_Concentration *nodes        
*add Cond Surface_Fix_Concentration *nodes                
*Add Cond Line_Fix_Concentration    *nodes        
*Add Cond Point_Fix_Concentration   *nodes
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, Conc = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!   Concentration Field    !!!!!!!!!!!!!!!
*set Cond  Concentration_Field        *nodes
*add Cond Volume_Concentration_Field *nodes
*add Cond Surface_Concentration_Field *nodes
*add Cond Line_Concentration_Field    *nodes
*add Cond Point_Concentration_Field   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, TConc %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!! Conditional Concentration  !!!!!!!!!!!!!!
*set Cond  Conditional_Concentration        *nodes
*add Cond Volume_Conditional_Concentration *nodes
*add Cond Surface_Conditional_Concentration *nodes
*add Cond Line_Conditional_Concentration    *nodes
*add Cond Point_Conditional_Concentration   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondConc;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!     Fix PhiVariable      !!!!!!!!!!!!!!!
*set Cond Fix_Variable         *nodes
*add Cond Volume_Fix_Variable *nodes        
*add Cond Surface_Fix_Variable *nodes                
*Add Cond Line_Fix_Variable    *nodes        
*Add Cond Point_Fix_Variable   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, Phi = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!    PhiVariable Field     !!!!!!!!!!!!!!!
*set Cond  Variable_Field        *nodes
*add Cond Volume_Variable_Field *nodes
*add Cond Surface_Variable_Field *nodes
*add Cond Line_Variable_Field    *nodes
*add Cond Point_Variable_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, TPhi %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!!     Conditional Phi        !!!!!!!!!!!!!!
*set Cond  Conditional_Variable        *nodes
*add Cond Volume_Conditional_Variable *nodes
*add Cond Surface_Conditional_Variable *nodes
*add Cond Line_Conditional_Variable    *nodes
*add Cond Point_Conditional_Variable   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondPhi;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!         Fix Beta         !!!!!!!!!!!!!!!
*set Cond Fix_Beta         *nodes
*add Cond Surface_Fix_Beta *nodes                
*Add Cond Line_Fix_Beta    *nodes        
*Add Cond Point_Fix_Beta   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Beta = %i"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!! Fix_Mesh_Deformation_Condition !!!!!!!!!!!!
*set Cond Fix_Mesh_Deformation         *nodes
*add Cond Volume_Fix_Mesh_Deformation  *nodes
*add Cond Surface_Fix_Mesh_Deformation *nodes
*Add Cond Line_Fix_Mesh_Deformation    *nodes
*Add Cond Point_Fix_Mesh_Deformation   *nodes
*loop nodes *OnlyInCond
    Node *NodesNum : DMesh  *cond(1);
*end
!!!!!!!!!!!!!!!   Fix_Mesh_Velocity   !!!!!!!!!!!!!!!
*set Cond Fix_Mesh_Velocity         *nodes *or(1,int) *or(2,int) *or(3,int)
*add Cond Volume_Fix_Mesh_Velocity  *nodes *or(1,int) *or(2,int) *or(3,int)
*add Cond Surface_Fix_Mesh_Velocity *nodes *or(1,int) *or(2,int) *or(3,int)
*Add Cond Line_Fix_Mesh_Velocity    *nodes *or(1,int) *or(2,int) *or(3,int)
*Add Cond Point_Fix_Mesh_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : VMesh  Fix %i %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
   EndBoundaryConditions;
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 TotalDefinition: VC_Inner_Iterations = *gendata(Velocity_Inner_Iterations), PR_Inner_Iterations = *gendata(Pressure_Inner_Iterations), TB_Inner_Iterations = *gendata(Turbulence_Inner_Iterations), TM_Inner_Iterations = *gendata(Temperature_Inner_Iterations);
ToleranceData: VelConvergenceNorm = *gendata(Velocity_Norm), PreConvergenceNorm = *gendata(Pressure_Norm), 
	       TemConvergenceNorm = *gendata(Temperature_Norm), BetConvergenceNorm = *gendata(WaveElevation_Norm);
    ContactSets;
*set var MatNumber = 1
*loop Materials *NotUsed
*if(strcmp(MatProp(1),"FSContact")==0 & strcmp(gendata(Solve_Fluid),"Yes")==0 & strcmp(gendata(Solve_Solid),"Yes")==0)
*set var WriteMSetTitle = 1
*for(ElemType=2;ElemType<=3;ElemType=ElemType+1)
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*endif
*set Cond Surface_Contact
*set var ElemNumber = 1
*set var WriteMeshTitle = 1
*loop Elems *OnlyInCond
*if(strcmp(MatProp(0),cond(1))==0)
*if(WriteMSetTitle==1)
    FSContact *MatNumber: Name = "*MatProp(0)"*\
*set var MatNumber =operation(MatNumber+1)
*if(strcmp(MatProp(Flow_OnOff),"On")==0)
, Couple_Flow*\
*endif
*if(strcmp(MatProp(Thermal_OnOff),"On")==0)
, Couple_Temp = "*Matprop(Thermal_Resistance);" *Matprop(Thermal_Resistance_Units)*\
*endif
;
        SpeciesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Spc OnOff" 1 Species_Properties 1 Spc_Units 1 23)
        EndSpeciesProperties;
        VariablesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Phi OnOff" 1 Variables_Properties 1 URV_Units 1 23)
        EndVariablesProperties;
*set var WriteMSetTitle = 0
*endif
*if(WriteMeshTitle==1)
*if(ElemType==1)
        Elements, ElmType = Linear, NNode = *ElemsNNode;
*elseif(ElemType==2)
        Elements, ElmType = Triangle, NNode = *ElemsNNode;
*elseif(ElemType==3)
        Elements, ElmType = Quadrilateral, NNode = *ElemsNNode;
*endif
*set var WriteMeshTitle = 0
*endif
 *ElemNumber *elemsConec
*set var ElemNumber = operation(ElemNumber+1)
*endif
*end Elems
*if(WriteMeshTitle==0)
        End Elements;
*endif
*end
*elseif(strcmp(MatProp(1),"FFContact")==0 & strcmp(gendata(Solve_Fluid),"Yes")==0)
*set var WriteMSetTitle = 1
*for(ElemType=2;ElemType<=3;ElemType=ElemType+1)
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*endif
*set Cond Surface_Contact
*set var ElemNumber = 1
*set var WriteMeshTitle = 1
*loop Elems *OnlyInCond
*if(strcmp(MatProp(0),cond(1))==0)
*if(WriteMSetTitle==1)
    FFContact *MatNumber: Name = "*MatProp(0)"*\
*set var MatNumber =operation(MatNumber+1)
*if(strcmp(MatProp(Flow_OnOff),"On")==0)
, Couple_Flow*\
*endif
*if(strcmp(MatProp(Thermal_OnOff),"On")==0)
, Couple_Temp = "*Matprop(Thermal_Resistance);" *Matprop(Thermal_Resistance_Units)*\
*endif
*if(strcmp(MatProp(MeshDeformation_OnOff),"On")==0)
, Couple_Mesh*\
*endif
;
        SpeciesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Spc OnOff" 1 Species_Properties 1 Spc_Units 1 23)
        EndSpeciesProperties;
        VariablesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Phi OnOff" 1 Variables_Properties 1 URV_Units 1 23)
        EndVariablesProperties;
*set var WriteMSetTitle = 0
*endif
*if(WriteMeshTitle==1)
*if(ElemType==1)
        Elements, ElmType = Linear, NNode = *ElemsNNode;
*elseif(ElemType==2)
        Elements, ElmType = Triangle, NNode = *ElemsNNode;
*elseif(ElemType==3)
        Elements, ElmType = Quadrilateral, NNode = *ElemsNNode;
*endif
*set var WriteMeshTitle = 0
*endif
 *ElemNumber *elemsConec *cond(2)
*set var ElemNumber = operation(ElemNumber+1)
*endif
*end Elems
*if(WriteMeshTitle==0)
        End Elements;
*endif
*end
*elseif(strcmp(MatProp(1),"SSContact")==0 & strcmp(gendata(Solve_Solid),"Yes")==0)
*set var WriteMSetTitle = 1
*for(ElemType=2;ElemType<=3;ElemType=ElemType+1)
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*endif
*set Cond Surface_Contact
*set var ElemNumber = 1
*set var WriteMeshTitle = 1
*loop Elems *OnlyInCond
*if(strcmp(MatProp(0),cond(1))==0)
*if(WriteMSetTitle==1)
    SSContact *MatNumber: Name = "*MatProp(0)"*\
*set var MatNumber =operation(MatNumber+1)
*if(strcmp(MatProp(Flow_OnOff),"On")==0)
, Couple_Flow*\
*endif
*if(strcmp(MatProp(Thermal_OnOff),"On")==0)
, Couple_Temp = "*Matprop(Thermal_Resistance);" *Matprop(Thermal_Resistance_Units)*\
*endif
*if(strcmp(MatProp(MeshDeformation_OnOff),"On")==0)
, Couple_Mesh*\
*endif
;
        SpeciesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Spc OnOff" 1 Species_Properties 1 Spc_Units 1 23)
        EndSpeciesProperties;
        VariablesProperties;
*tcl(TdynOutput::FormatMatlvalIf *MatProp(0) "Rest_Phi OnOff" 1 Variables_Properties 1 URV_Units 1 23)
        EndVariablesProperties;
*set var WriteMSetTitle = 0
*endif
*if(WriteMeshTitle==1)
*if(ElemType==1)
        Elements, ElmType = Linear, NNode = *ElemsNNode;
*elseif(ElemType==2)
        Elements, ElmType = Triangle, NNode = *ElemsNNode;
*elseif(ElemType==3)
        Elements, ElmType = Quadrilateral, NNode = *ElemsNNode;
*endif
*set var WriteMeshTitle = 0
*endif
 *ElemNumber *elemsConec *cond(2)
*set var ElemNumber = operation(ElemNumber+1)
*endif
*end Elems
*if(WriteMeshTitle==0)
        End Elements;
*endif
*end
*endif
*end
    EndContactSets;
EndProblem;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*endif

